package cn.com.ctop.accountvideoquarterinfo.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.util.oConvertUtils;
import cn.com.ctop.accountvideoquarterinfo.entity.AccountVideoQuarterInfo;
import cn.com.ctop.accountvideoquarterinfo.service.IAccountVideoQuarterInfoService;

import java.util.Date;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * 绩效明细_账户下所有视频的季度消耗数据
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2020-04-13
 */
@Slf4j
@Api(tags = "绩效明细_账户下所有视频的季度消耗数据")
@RestController
@RequestMapping("/accountvideoquarterinfo/accountVideoQuarterInfo")
public class AccountVideoQuarterInfoController {
    @Autowired
    private IAccountVideoQuarterInfoService accountVideoQuarterInfoService;

    /**
     * 分页列表查询
     *
     * @param accountVideoQuarterInfo
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @AutoLog(value = "绩效明细_账户下所有视频的季度消耗数据-分页列表查询")
    @ApiOperation(value = "绩效明细_账户下所有视频的季度消耗数据-分页列表查询", notes = "绩效明细_账户下所有视频的季度消耗数据-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<AccountVideoQuarterInfo>> queryPageList(AccountVideoQuarterInfo accountVideoQuarterInfo,
                                                                @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                                @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                                HttpServletRequest req) {
        Result<IPage<AccountVideoQuarterInfo>> result = new Result<IPage<AccountVideoQuarterInfo>>();
        QueryWrapper<AccountVideoQuarterInfo> queryWrapper = QueryGenerator.initQueryWrapper(accountVideoQuarterInfo, req.getParameterMap());
        Page<AccountVideoQuarterInfo> page = new Page<AccountVideoQuarterInfo>(pageNo, pageSize);
        IPage<AccountVideoQuarterInfo> pageList = accountVideoQuarterInfoService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param accountVideoQuarterInfo
     * @return
     */
    @AutoLog(value = "绩效明细_账户下所有视频的季度消耗数据-添加")
    @ApiOperation(value = "绩效明细_账户下所有视频的季度消耗数据-添加", notes = "绩效明细_账户下所有视频的季度消耗数据-添加")
    @PostMapping(value = "/add")
    public Result<AccountVideoQuarterInfo> add(@RequestBody AccountVideoQuarterInfo accountVideoQuarterInfo) {
        Result<AccountVideoQuarterInfo> result = new Result<AccountVideoQuarterInfo>();
        try {
            accountVideoQuarterInfoService.save(accountVideoQuarterInfo);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param accountVideoQuarterInfo
     * @return
     */
    @AutoLog(value = "绩效明细_账户下所有视频的季度消耗数据-编辑")
    @ApiOperation(value = "绩效明细_账户下所有视频的季度消耗数据-编辑", notes = "绩效明细_账户下所有视频的季度消耗数据-编辑")
    @PutMapping(value = "/edit")
    public Result<AccountVideoQuarterInfo> edit(@RequestBody AccountVideoQuarterInfo accountVideoQuarterInfo) {
        Result<AccountVideoQuarterInfo> result = new Result<AccountVideoQuarterInfo>();
        AccountVideoQuarterInfo accountVideoQuarterInfoEntity = accountVideoQuarterInfoService.getById(accountVideoQuarterInfo.getId());
        if (accountVideoQuarterInfoEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = accountVideoQuarterInfoService.updateById(accountVideoQuarterInfo);
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "绩效明细_账户下所有视频的季度消耗数据-通过id删除")
    @ApiOperation(value = "绩效明细_账户下所有视频的季度消耗数据-通过id删除", notes = "绩效明细_账户下所有视频的季度消耗数据-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            accountVideoQuarterInfoService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "绩效明细_账户下所有视频的季度消耗数据-批量删除")
    @ApiOperation(value = "绩效明细_账户下所有视频的季度消耗数据-批量删除", notes = "绩效明细_账户下所有视频的季度消耗数据-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<AccountVideoQuarterInfo> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<AccountVideoQuarterInfo> result = new Result<AccountVideoQuarterInfo>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.accountVideoQuarterInfoService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @AutoLog(value = "绩效明细_账户下所有视频的季度消耗数据-通过id查询")
    @ApiOperation(value = "绩效明细_账户下所有视频的季度消耗数据-通过id查询", notes = "绩效明细_账户下所有视频的季度消耗数据-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<AccountVideoQuarterInfo> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<AccountVideoQuarterInfo> result = new Result<AccountVideoQuarterInfo>();
        AccountVideoQuarterInfo accountVideoQuarterInfo = accountVideoQuarterInfoService.getById(id);
        if (accountVideoQuarterInfo == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(accountVideoQuarterInfo);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<AccountVideoQuarterInfo> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                AccountVideoQuarterInfo accountVideoQuarterInfo = JSON.parseObject(deString, AccountVideoQuarterInfo.class);
                queryWrapper = QueryGenerator.initQueryWrapper(accountVideoQuarterInfo, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<AccountVideoQuarterInfo> pageList = accountVideoQuarterInfoService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "绩效明细_账户下所有视频的季度消耗数据列表");
        mv.addObject(NormalExcelConstants.CLASS, AccountVideoQuarterInfo.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("绩效明细_账户下所有视频的季度消耗数据列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<AccountVideoQuarterInfo> listAccountVideoQuarterInfos = ExcelImportUtil.importExcel(file.getInputStream(), AccountVideoQuarterInfo.class, params);
                accountVideoQuarterInfoService.saveBatch(listAccountVideoQuarterInfos);
                return Result.ok("文件导入成功！数据行数:" + listAccountVideoQuarterInfos.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
